CustomTimer = CustomTimer or {}

--@CustomTimer creates a functioning timer because SetTimer did not work with Cancel
--@returns an instance of its self
--created 25.08.2020 13:19 Sebastian Steininger, changed 25.08.2020 13:19 Sebastian Steininger
function CustomTimer:new(nTime, fnCallback, bRebeat)
    local objCustomTimer = {}
    setmetatable(objCustomTimer, self)
    self.__index = self
    objCustomTimer.bCanceled = false
    objCustomTimer.bRebeat = bRebeat or false
    objCustomTimer.nTime = nTime
    objCustomTimer.fnCallback = fnCallback
    return objCustomTimer
end

--@CustomTimer:Start starts the timer
--created 25.08.2020 13:19 Sebastian Steininger, changed 25.08.2020 13:19 Sebastian Steininger
function CustomTimer:Start()
    local fnCallBack = function(timer, skips) 
		  self:CallBack(timer, skips) 
	   end
    self.timer = C4:SetTimer(self.nTime, fnCallBack, self.bRebeat)
end

--@CustomTimer:Cancel The running timer
--created 25.08.2020 13:19 Sebastian Steininger, changed 25.08.2020 13:19 Sebastian Steininger
function CustomTimer:Stop()
    self.bCanceled = true
    Dbg:Debug("CustomTimer canceled!")
end

--@CustomTimer:CallBack handels the timer callback
--created 25.08.2020 13:19 Sebastian Steininger, changed 25.08.2020 13:19 Sebastian Steininger
function CustomTimer:CallBack(timer, skips)
    Dbg:Debug("CallBack from timer")
    skips = skips or 0
    timer = timer or nil
    Dbg:Debug(tostring(self.bCanceled))
    if(self.bCanceled==false)then
	   self.fnCallback()
    end
end