UrlCoder = UrlCoder or {}

--@UrlCoder:new is called if a new instance of UrlCoder is created
--created 28.07.2020 13:45 Sebastian Steininger, changed 28.07.2020 13:50 Sebastian Steininger
function UrlCoder:new()
    return self
end

char_to_hex = function(c)
	   return string.format("%%%02X", string.byte(c))
    end
    
hex_to_char = function(x)
	   return string.char(tonumber(x, 16))
    end

--@UrlCoder:UrlDecode urlencodes a string
--created 28.07.2020 13:45 Sebastian Steininger, changed 28.07.2020 13:50 Sebastian Steininger
function UrlCoder:UrlEncode(url)
  if url == nil then
    return
  end
  url = url:gsub("\n", "\r\n")
  url = url:gsub("([^%w ])", char_to_hex)
  url = url:gsub(" ", "+")
  return url
end

--@UrlCoder:UrlDecode urldecodes a string
--created 28.07.2020 13:45 Sebastian Steininger, changed 28.07.2020 13:50 Sebastian Steininger
function UrlCoder:UrlDecode(url)
  if url == nil then
    return
  end
  url = url:gsub("+", " ")
  url = url:gsub("%%(%x%x)", hex_to_char)
  return url
end