TCPClient = TCPClient or {}

--TCPClient:new creates/starts a tcp-client
--created 11.08.2020 09:45 Sebastian Steininger, changed 11.08.2020 13:12 Sebastian Steininger
function TCPClient:new(communicator_)
    local objTCPClient = {}
    setmetatable(objTCPClient, self)
    self.__index = self
    objTCPClient.client = C4:CreateTCPClient()
	   --Events are self explaning
	   --created 11.08.2020 09:45 Sebastian Steininger, changed 11.08.2020 13:12 Sebastian Steininger
	   :OnConnect(function(client)
		  local remote = client:GetRemoteAddress()
		  print("Connected to " .. remote.ip .. ":" .. remote.port)
		  client:Write("lc/Connected\r\n")
		  client:ReadUntil("\r\n") 
	   end)
	   :OnDisconnect(function(client, errCode, errMsg)
		  Dbg:Trace("Disconnected: Trying to reconnect in 1s")
		  C4:SetTimer(1000,function() communicator_.tcpClient:Connect() end, false)
		  end)
	   :OnRead(function(client, data)
		  Dbg:Debug("Date received")
		  if(client~=nil) then
			 communicator_:ReceivedData(data,client)
			 client:ReadUntil("\r\n")
		  end
		  end)
		 
	   :OnError(function(client, errCode, errMsg)
		  --complete(nil, "Error " .. errCode .. ": " .. errMsg)
		  Dbg:Trace("Error: Trying to reconnect in 1s")
		  C4:SetTimer(1000,function() communicator_.tcpClient:Connect() end, false)
	   end)

    return objTCPClient
end

--TCPClient:connect connects the client to the server
--created 25.08.2020 11:49 Sebastian Steininger, changed 26.08.2020 11:49 Sebastian Steininger
function TCPClient:CreateClient()
    local communicator_ = self.communicator
    self.client = C4:CreateTCPClient()
	   --Events are self explaning
	   :OnConnect(function(client)
		  local remote = client:GetRemoteAddress()
		  print("Connected to " .. remote.ip .. ":" .. remote.port)
		  client:Write("lc/Connected\r\n")
		  client:ReadUntil("\r\n") 
	   end)
	   :OnDisconnect(function(client, errCode, errMsg)
		  Dbg:Trace("Disconnected: Trying to reconnect in 1s")
		  C4:SetTimer(1000,function() communicator_.tcpClient:Connect() end, false)
		  end)
	   :OnRead(function(client, data)
		  Dbg:Debug("Date received")
		  if(client~=nil) then
			 communicator_:ReceivedData(data,client)
			 client:ReadUntil("\r\n")
		  end
		  end)
		 
	   :OnError(function(client, errCode, errMsg)
		  --complete(nil, "Error " .. errCode .. ": " .. errMsg)
		  Dbg:Trace("Error: Trying to reconnect in 1s")
		  C4:SetTimer(1000,function() communicator_.tcpClient:Connect() end, false)
	   end)
end

--TCPClient:connect connects the client to the server
--created 11.08.2020 09:45 Sebastian Steininger, changed 26.08.2020 11:57 Sebastian Steininger
function TCPClient:Connect()
    Dbg:Debug("Trying to connect to the server")
    if(self.client) then
	   Dbg:Info("Client connecting...")
	   self.client:Connect("!local", 40)
    else
	   self.client = self:CreateClient()
    end
end

--TCPClient:Send sends a message to the connected server
--created 11.08.2020 09:45 Sebastian Steininger, changed 11.08.2020 13:12 Sebastian Steininger
function TCPClient:Send(strData)
    Dbg:Debug("send data to server: "..strData)
    strData = strData.."\r\n"
    self.client:Write(strData)
    Dbg:Debug("Data sent")
end

--TCPClient:Close closes the server/client connection
--created 11.08.2020 09:45 Sebastian Steininger, changed 11.08.2020 13:12 Sebastian Steininger
function TCPClient:Close()
    self.client:Close()
end