tcpClient = require('TCPClient')

---------------------------------------- Class Communicator ----------------------------------------
Communicator = Communicator or {}

--only until connectionProtocoll is changed than aes and rsa are not necessary

--@Communicator:new creates a TCP for communicating with the Communicator Driver
--@param strDomainIp is the ip/Domain of the miniserver
--@param port is the port of the miniserver (default 443 for wss)
--created 28.07.2020 09:45 Sebastian Steininger, changed 10.08.2020 16:10 Sebastian Steininger
function Communicator:new(fncRegisterReceiveFunctions)
    local objCommunicator = {}
    setmetatable(objCommunicator, self)
    self.__index = self
    objCommunicator.registeredReceiveFunctions = {}
    objCommunicator.tcpClient = TCPClient:new(objCommunicator)
    objCommunicator.tcpClient:Connect(objCommunicator.tcpClient.client)
    objCommunicator.fncRegisterReceiveFunctions = fncRegisterReceiveFunctions
    return objCommunicator
end

--@Communicator:SendCommand sends a command to the miniserver
--@details Tests if the command is not an empty sring
--@param strCommand is the command that sould be send
--created 28.07.2020 09:23 Sebastian Steininger, changed 10.08.2020 16:10 Sebastian Steininger
function Communicator:SendCommand(strCommand)
    self.tcpClient:Send(strCommand)
end

--@Communicator:CloseConnection closes the websocket connection
--created 28.07.2020 09:50 Sebastian Steininger, changed 10.08.2020 16:10 Sebastian Steininger
function Communicator:CloseConnection()
    Dbg:Debug("CloseConnection")
end

function Communicator:RegisterReceiveFunction(uuid, function_)
    Dbg:Debug("register receive function")
    Dbg:Debug(uuid)
    self.registeredReceiveFunctions[uuid] = function_
    self.tcpClient:Send("lc/register/"..uuid)
end

--@Communicator:ReceivedData handles received data
--@param data is the received data from the miniserver
--created 28.07.2020 09:55 Sebastian Steininger, changed 10.08.2020 16:10 Sebastian Steininger
function Communicator:ReceivedData(data, client)
    Dbg:Trace("Data received")
    Dbg:Trace(data)
    if(data and data ~="") then
	   if(string.match(data, "lc/"))then
		  Dbg:Info("Local command received")
		  if(string.match(data, "lc/start"))then
			 Dbg:Info("WebsocketConnection starts")
			 self.fncRegisterReceiveFunctions()
		  end
	   end
	   message = C4:JsonDecode(data)
	   if(message) then
		  Dbg:Trace(message.strUuid)
		  if(self.registeredReceiveFunctions[message.strUuid]) then
			 self.registeredReceiveFunctions[message.strUuid](message)
		  end
	   end
    end
end